Subject: Re: [PATCH v2 10/19] pack-bitmap: add support for bitmap indexes

From: Junio C Hamano <[email-masked]>
Date: Mon, 28 Oct 2013 08:22:07 -0700

Jeff King <[email-masked]> writes:

> On Fri, Oct 25, 2013 at 08:26:29PM -0400, Jeff King wrote:
>
>> On Fri, Oct 25, 2013 at 04:06:19PM -0700, Junio C Hamano wrote:
>> 
>> > Jeff King <[email-masked]> writes:
>> > 
>> > > diff --git a/pack-bitmap.c b/pack-bitmap.c
>> > > new file mode 100644
>> > > index 0000000..73c52fd
>> > > --- /dev/null
>> > > +++ b/pack-bitmap.c
>> > > @@ -0,0 +1,965 @@
>> > > +#include <stdlib.h>
>> > > +
>> > > +#include "cache.h"
>> > 
>> > You among all people already know why this is bad, no?
>> 
>> Yes, I am well aware of why we do not want it. I thought I removed that,
>> but it appears I missed one. Sorry.
>
> In addition to that one, there are a few other system header includes:
>
>   - the ewah/*.c files include the necessary standard headers, and do
>     not include git-compat-util.h at all. I do not really consider these
>     "git code", but rather a black box we have imported into the tree
>     to ease the dependency chain. So in that sense, they operate like
>     xdiff/*.c or compat/regex/*.c, which also compile on
>     their own (and can get away with it because they are mostly standard
>     C and do not do "system" things.

Right; I didn't comment on the bare inclusions of system headers in
these files exactly because I shared that reasoning.

>     However, the code in the ewah/ directory has been hacked up a bit
>     from its original, and ewah_io.c _does_ include "git-compat-util.h".
>     So it may make sense to consider our copy a fork and git-ify it
>     more.

Yeah, sounds very sensible.